'PSB 8x8 Tile Font Driver Demo (C) Copyright 2009 Rayslogic.com, LLC
' Demos a 8x16 font from 8x8 tiles for 60 column display

CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


  'LCD is 480x272 giving 60x34 of 8x8 tiles  (17 rows of text)
  cols = 60
  rows = 17*2  
  screensize = cols * rows
  fontsize=4080  '#bytes in font data = 255*16
  

VAR

  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight
'  long  lcd_pFont       'Used to pass address of font

  word  screen[screensize]
  long  col, row, color
  long  boxcolor,ptr

  word  pFont

DAT       'Data for user font
padding LONG  "A"[4] 'alignment padding for the following user defined characters
TileFont long
file "8x8_tilefont.dat"


OBJ
  lcd : "PSB_8x8_TiledLcdDriver"  'Modified to drive 4.3" TFT
  i2c: "PSB_I2CDriver"  

pub Main|i,x,y,z

  'First, need to prepare user font for display (need to move so that last four bits of address are all zeroes!)
  '16 byte align the user font
  pFont := @TileFont & $FFF0 'destination
  bytemove(pFont,@TileFont,fontsize)
  pFont>>=4  'shift font pointer four bits right for ease of use later
    
  'Start up Display
  'clear screen
  print($100)
  'start driver
  lcd_enable:=1
  lcd_videobase := @screen
  lcd_colorbase := @vgacolors
  lcd_backlight:=3  '1=bright, 16=medium, 32=dark
  'lcd_pFont:=@TileFont 'pass address of font
  lcd.start(@lcd_status)

  i2c.initialize


  'Show the font in a couple colors
  color:=0 
  repeat 4
    
    repeat i from 0 to 255
      print(i)
    color++

  
  repeat



                            
   



      


PUB WaitStylusUp
  'Wait for stylus to be up
  repeat
    waitcnt(cnt+clkfreq/100)  
    if ina[lcd#TouchIrqPin]<>0
    return


PRI PrintStr(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    print(byte[stringptr++])

PUB print(c) | i, k

  case c
    $00..$FF:           'character?
      k := color << 1  'text colors are defined in pairs... 
      screen[row * cols + col] := (k+1) << 12 + pFont + c  
      screen[(row + 1) * cols + col] := k << 12 + pFont + c  
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@screen, pFont+32, screensize)
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $10D:               'return?
      newline

    $110..$11F:         'select color?
      color := c & $F


' New line

PRI newline : i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
    wordfill(@screen[(rows-2)*cols], pFont+32, cols<<1)


' Data

PRI dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    print("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      print(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      print("0")
    i /= 10

PRI hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    print(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))
    
DAT 'Default Touchscreen Calibrations
touchx0 long 2713
touchdx long 123
touchy0 long 4590
touchdy long 206

finder byte "X"[100]



DAT
                    'Note:  Can only use 16 longs of colors with this driver...
vgacolors               long
                        long    $F00CF00C       '0blue background with yellow letters
                        long    $F0F00C0C       '1
                        long    $08A808A8       '2green
                        long    $0808A8A8       '3
                        long    $50005000       '4blue
                        long    $50500000       '5
                        long    $FC00FC00       '6white
                        long    $FCFC0000       '7
                        long    $FF80FF80       '8red/white
                        long    $FFFF8080       '9
                        long    $FFC03000      '10'Colors for Graphics
spcl                    long    $F0FF9C0C       '11 'Color0  white
                        long    $F0C09C0C        '12 Color1  red
                        long    $F030000C      '13 Color2  green
                        long    $F000000C      '14 Color3  black
                        long    $FF0C9C0C        '15 fill screen

